#include "syhi.h"
#include <sys/types.h>
#include <string.h>
#include <pcre.h>
#include <stdio.h>

#include <assert.h>

void highlight(GtkTextView *view)
{
	GtkTextIter start, end;
	GtkTextBuffer *buf;
	int textlen;

	GtkTextTag *tag;

	const char *error;
	int erroffset;
	int sub[12];
	char *pattern;
	int num;
	char c;
	
	GdkColor color;
	
	GTimer *timer;
	
	int startidx = 0, retval, linecount = 0;
	char *text, *mytext;

	FILE *sf;
	pcre *pbuf;
	char *line;
	
	double time = 0;
	
	buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
	textlen = gtk_text_buffer_get_char_count(buf);
	
	gtk_text_buffer_get_bounds(buf, &start, &end);
	text = gtk_text_buffer_get_text(buf, &start, &end, TRUE);
	
	//open syntax file and apply expressions
	sf = fopen("c.syntax", "r");
	if (!sf)
	{
		printf("could not open syntax file in current directory.\n");
		return;
	}
	
	pattern = malloc(1024); // FIXME
	line = malloc(512); // FIXME
	
	while ( retval = fscanf (sf, "%s %d %d %d\n", pattern, &color.red, &color.green, &color.blue) ) //FIXME for empty lines. be more flexible in general.
	{
		printf("linecount is %d\n", linecount);
		linecount++;
		startidx = 0;		
		
		color.red *= 257;
		color.green *= 257;
		color.blue *= 257;
		
		
		/*
			//check for invalid lines like this:
			
			if (retval < 4...)
			{
				printf("invalid line\n");
				break;
			}
		*/
		
		if (retval == EOF)
		{
			printf("EOF at char %d\n", ftell(sf));
			break;
		}
		
		printf("current pattern: %s\n", pattern);
		printf("got colors: [%d][%d][%d]\n", color.red, color.green, color.blue);
		printf("current file pos: %d\n", ftell(sf));
			
		pbuf = pcre_compile(pattern, PCRE_MULTILINE | PCRE_CASELESS, &error, &erroffset, NULL);
		if (pbuf == NULL)
		{
			printf("error compiling regex at char %d: %s\n", erroffset, error);
			return;
		}
	
		retval = pcre_exec(pbuf, NULL, text, strlen(text), startidx, 0, sub, 12);
		printf("first retval is %d, textlen is %d\n", retval, textlen);
		
		printf("creating tag number %d\n", linecount-1);
		tag = gtk_text_buffer_create_tag(buf, NULL, "background-gdk", &color, NULL);
		
		timer = g_timer_new();
		
		while (retval >= 0 && sub[2] < textlen)
		{		
			printf("enter loop. ");
			printf("match: %d - %d\n", sub[2], sub[3]);
						
			//get iters at submatch position(s)
			assert(&start != NULL);
			assert(&end != NULL);
			gtk_text_buffer_get_iter_at_offset(buf, &start, sub[2]);
			gtk_text_buffer_get_iter_at_offset(buf, &end, sub[3]);
			
			gtk_text_buffer_apply_tag(buf, tag, &start, &end);
			
			startidx = sub[3] + 1;
			
			retval = pcre_exec(pbuf, NULL, text, strlen(text), startidx, 0, sub, 12);
			//printf("retval: %d\n", retval);
		}
		g_timer_stop(timer);
		printf("highlighting pass done, effective time: %f\n", g_timer_elapsed(timer, NULL));
		time += g_timer_elapsed(timer, NULL);
	}

	printf("--------------------------------------\nfinished, total effective highlighting time: %f\n", time);
	
	if (sf != NULL)
		fclose(sf);
	
	return;
}


/*

	syhi plugin api
	---------------
	
	void init ( void (*errfun)(char *msg) = NULL, void (*statusfun)(double percent) = NULL, double updatestep = 0);
	
	int select_module (lang_t lang);
	// OR //
	int load_rules_from_file (char *file);
	
	void highlight ( GtkTextBuffer *buf, GtkTextIter start, GtkTextIter end );
	
	void cleanup ();
	
	where...
		lang_t is an enum, like { LANG_C, LANG_C++ }
*/
